<template>
  <div class="page">
    <div
      class="back-link"
      @click="$router.push(routeFrom && routeFrom.name ? routeFrom : { name: 'Datasets' })"
    >
      <b-icon-chevron-left font-scale="1.3" />
      <span>
        {{ (routeFrom && routeFrom.name === 'Datasets') || !routeFrom ? 'Jeux de données' : 'Jeu de donnée' }}
      </span>
    </div>
    <div class="top">
      <h2 style="margin-left: 1rem;">
        {{ currentDataset.display_name }}
      </h2>
      <div class="default-permission">
        <div>
          Par défaut, l'accès à ce jeu de données est : 
        </div>
        <div class="permissions">
          <b-overlay :show="busy" rounded="lg" opacity="0.6">
            <template #overlay>
              <div class="d-flex align-items-center">
                <b-spinner small type="grow" variant="secondary"></b-spinner>
                <b-spinner type="grow" variant="dark" style="margin: 0 0.5em;"></b-spinner>
                <b-spinner small type="grow" variant="secondary"></b-spinner>
              </div>
            </template>
            <button
              v-for="permission of [
                { label: 'Privé', level: 0 },
                { label: 'Recherche', level: 1},
                { label: 'Consultation', level: 2 },
                { label: 'Téléchargement', level: 3 }
              ]"
              :key="permission.level"
              :class="permission.level === currentDataset.default_permission_level ? 'btn-success' : 'btn-secondary'"
              :disabled="permission.level === currentDataset.default_permission_level"
              class="btn btn-sm"
              @click="askToChangePermissionsLevel({ level: permission.level, action: setDatasetDefaultPermissionLevel })"
            >
              {{ permission.label }}
            </button>
          </b-overlay>
        </div>
      </div>
    </div>
    <b-row class="row-cols-2" style="min-width: 1230px;">
      <b-col class="col-10">
        <div class="actions">
          <Multiselect
            v-model="action"
            :options="actionsOptions"
            track-by="code"
            label="label"
            selectLabel=""
            selectedLabel=""
            deselectLabel=""
            :searchable="false"
            placeholder="Choisir une action"
          >
            <span slot="noResult">
              Aucune action.
            </span>
            <span slot="noOptions">
              Aucune action.
            </span>
          </Multiselect>
          <b-button
            variant="primary"
            :disabled="action === null"
            @click="askToChangePermissionsLevel({ level: null, action: sendDatasetPermissionAction })"
          >
            Envoyer
          </b-button>
          <SearchTable
            :placeholder="'Rechercher un(e) groupe/organisation ...'"
            :searchFunction="SEARCH_DATASET_USERGROUPS_PERMISSIONS"
            @loading="loadSearch"
          />
        </div>
        <div class="custom-table">
          <b-overlay
            style="min-height: 7em;"
            :show="loading"
            :variant="'white'"
            :opacity="0.5"
            :blur="'2px'"
            rounded="sm"
          >
            <CustomTable
              :fields="fields"
              :items="items"
              :selectable="true"
              :allowDeletion="false"
              :sortFunction="GET_DATASET_USERGROUPS_PERMISSIONS"
              @sorted="setTableSorted"
              @select="setSelectedPermissions"
              @select-all="setSelectedAll"
              @loding="setTableLoader"
            />
            <Pagination
              v-if="currentUsergroupsPermissionsCount > 50"
              :nbPages="Math.ceil(currentUsergroupsPermissionsCount / 50)"
              @change-page="changeTablePage"
            />
          </b-overlay>
        </div>
      </b-col>
      <b-col class="col-2 filters-col">
        <ul class="list-group">
          <li class="list-group-item active">
            Filtres
          </li>
          <li class="list-group-item">
            Type de groupe
          </li>
          <li class="list-group-item" style="padding: 0;">
            <div class="btn-group-vertical">
              <b-button
                v-for="(filter, id) in groupFilters"
                :key="id"
                :pressed.sync="filter.state"
                variant="outline-primary"
                @click="setGroupFilters(filter)"
              >
                {{ filter.label }}
              </b-button>
            </div>
          </li>
          <li class="list-group-item">
            Types d'organisations
          </li>
          <li class="list-group-item" style="padding: 0;">
            <Multiselect
              v-model="organisationTypeFilter"
              class="filter-dropdown"
              :options="organisationsTypes"
              track-by="codename"
              label="display_name"
              selectLabel=""
              selectedLabel=""
              deselectLabel=""
              :searchable="false"
              placeholder="Type d'organisation"
            />
          </li>
          <li class="list-group-item">
            Niveau d'accès
          </li>
          <li class="list-group-item" style="padding: 0;">
            <div class="btn-group-vertical">
              <b-button
                v-for="(filter, id) in accessLevelFilters"
                :key="id"
                :pressed.sync="filter.state"
                variant="outline-primary"
                @click="setAccessLevelFilters(filter)"
              >
                {{ filter.label }}
              </b-button>
            </div>
          </li>
        </ul>
      </b-col>
    </b-row>
    <ChangeDatasetPermissions
      :open="changingDatasetPermissions"
      :all="nextAction === sendDatasetPermissionAction && !selectedAll ? false : true"
      @update="nextAction"
      @hide="changingDatasetPermissions = false"
    />
  </div>
</template>

<script>
import CustomTable from '@/components/CustomTable.vue';
import Pagination from '@/components/Pagination.vue';
import SearchTable from '@/components/SearchTable.vue';
import ChangeDatasetPermissions from '@/components/Modals/ChangeDatasetPermissions.vue';
import Multiselect from 'vue-multiselect';

import { mapState, mapMutations, mapActions } from 'vuex';

export default {
  name: 'DatasetPermissions',

  components: {
    CustomTable,
    Pagination,
    SearchTable,
    ChangeDatasetPermissions,
    Multiselect
  },

  data() {
    return {
      routeFrom: null,
      loading: false,
      busy: false,
      changingDatasetPermissions: false,
      permissionLevelToChange:  null,
      nextAction: () => {},
      actionsOptions: [
        {
          label: 'Supprimer les droits d\'accès',
          code: 0
        },
        {
          label: 'Accorder les droits de recherche',
          code: 1
        },
        {
          label: 'Accorder les droits de consultation',
          code: 2
        },
        {
          label: 'Accorder les droits de téléchargement',
          code: 3
        }
      ],
      action: null,
      selectedAll: false,
      fields: [
        {
          key: 'Nom',
          apiName: 'display_name',
          sortable: true,
          width: '18%',
          centered: false
        },
        {
          key: 'Type',
          apiName: 'usergroup_type',
          sortable: true,
          width: '10%',
          centered: false
        },
        {
          key: 'Type d\'organisation',
          apiName: 'organisation_type',
          sortable: true,
          width: '15%',
          centered: false
        },
        {
          key: 'Convention signée',
          sortable: false,
          width: '12%',
          centered: true
        },
        {
          key: 'Convention',
          sortable: false,
          width: '8%',
          centered: true
        },
        {
          key: 'Niveau d\'accès',
          apiName: 'level',
          sortable: true,
          width: '13%',
          centered: true
        }
      ],
      groupFilters: [
        {
          label: 'Tous',
          type: '',
          state: true,
        },
        {
          label: 'Organisations',
          type: 'organisation',
          state: false,
        },
        {
          label: 'Groupes d\'utilisateurs',
          type: 'user-group',
          state: false,
        },
        {
          label: 'Groupes d\'organisations',
          type: 'group-of-organisation',
          state: false,
        }
      ],
      organisationTypeFilter: null,
      accessLevelFilters: [
        {
          label: 'Tous',
          access: '',
          state: true,
        },
        {
          label: 'Aucun accès',
          access: 0,
          state: false,
        },
        {
          label: 'Recherche',
          access: 1,
          state: false,
        },
        {
          label: 'Consultation',
          access: 2,
          state: false,
        },
        {
          label: 'Téléchargement',
          access: 3,
          state: false,
        },
      ],
      tableSorted: {
        direction: null,
        field: null
      }
    }
  },

  computed: {
    ...mapState('datasets', [
      'currentUsergroupsPermissionsCount',
      'currentUsergroupsPermissions',
      'datasetsList',
      'currentDataset',
      'isPermissionsListSearched',
      'selectedPermissions'
    ]),

    ...mapState('organisations', [
      'organisationsTypes',
    ]),

    ...mapState('usergroups', [
      'usergroupsTypes',
    ]),

    items() {
      return this.currentUsergroupsPermissions.map(el => {
        return {
          id: el.id,
          'Nom': el.usergroup.display_name,
          'Type': el.usergroup.usergroup_type.display_name,
          'Type d\'organisation':
            el.usergroup.organisation && el.usergroup.organisation.organisation_type && this.organisationsTypes.find(e => e.id === el.usergroup.organisation.organisation_type) ?
              this.organisationsTypes.find(e => e.id === el.usergroup.organisation.organisation_type).display_name :
              null,
          'Convention signée': el.usergroup.organisation ? el.usergroup.organisation.agreement_signed : null,
          'Convention': el.usergroup.organisation && el.usergroup.organisation.agreement_file ? el.usergroup.organisation.agreement_file.url : null,
          'Niveau d\'accès': el.level //this.accessLevelFilters.find(level => el.level === level.access).label
        }
      });
    }
  },

  watch: {
    organisationTypeFilter(newValue) {
      if (newValue) {
        this.PRE_SET_USERGROUPS_PERMISSIONS_FILTERS({
          filter: 'organisation_type_id',
          value: newValue.id
        });
        this.getDatasetPermissions();
      } else {
        this.PRE_RESET_USERGROUPS_PERMISSIONS_FILTERS('organisation_type_id');
        this.getDatasetPermissions();
      }
    }
  },

  created() {
    this.GET_DATASET_DETAIL(this.$route.params.id);
    if (
      (this.currentUsergroupsPermissions.length === 0 ||
      this.currentUsergroupsPermissions[0].dataset.toString() !== this.$route.params.id)
      && !this.isPermissionsListSearched
    ) {
      this.getDatasetPermissions();
    }
    if (this.organisationsTypes.length === 0) {
      this.GET_ORGANISATIONS_TYPES();
    }
    if (this.usergroupsTypes.length === 0) {
      this.GET_USERGROUPS_TYPES();
    }
  },

  mounted() {
    // Watch modal closing event
    this.$root.$on('bv::modal::hide', () => {
      this.changingDatasetPermissions = false;
    });
  },

  beforeRouteEnter(to, from, next) {
    next((vm) => {
        vm.routeFrom = from;
    });
  },

  methods: {
    ...mapMutations('datasets', [
      'SET_SELECTED_PERMISSIONS',
      'RESET_SELECTED_PERMISSIONS'
    ]),
    ...mapActions('datasets', [
      'PRE_SET_USERGROUPS_PERMISSIONS_FILTERS',
      'PRE_REMOVE_USERGROUPS_PERMISSIONS_FILTERS',
      'PRE_RESET_USERGROUPS_PERMISSIONS_FILTERS',
      'GET_DATASET_USERGROUPS_PERMISSIONS',
      'SET_DATASET_USERGROUPS_PERMISSIONS',
      'SEARCH_DATASET_USERGROUPS_PERMISSIONS',
      'GET_DATASET_DETAIL',
      'PATCH_DATASET'
    ]),
    ...mapActions('organisations', [
      'GET_ORGANISATIONS_TYPES'
    ]),
    ...mapActions('usergroups', [
      'GET_USERGROUPS_TYPES'
    ]),

    getDatasetPermissions(page) {
      this.loading = true;
      this.GET_DATASET_USERGROUPS_PERMISSIONS({
        ...this.tableSorted,
        id : this.$route.params.id || this.currentUsergroupsPermissions[0].dataset.toString(),
        page: page
      })
        .then(() => {
          this.loading = false;
        })
        .catch((err) => {
          console.error(err);
        });
    },

    askToChangePermissionsLevel(e) {
      this.nextAction = e.action;
      this.permissionLevelToChange = e.level;
      this.changingDatasetPermissions = true;
    },

    setDatasetDefaultPermissionLevel() {
      const data = {
        default_permission_level: this.permissionLevelToChange
      };
      this.busy = true;
      this.loading = true;
      this.PATCH_DATASET({
        id: this.currentDataset.id,
        data: data
      })
      .then(() => {
        this.GET_DATASET_DETAIL(this.$route.params.id)
          .then(() => {
            this.busy = false;
            this.getDatasetPermissions();
            this.nextAction = () => {};
            this.permissionLevelToChange = null;
            this.changingDatasetPermissions = false;
          })
          .catch((err) => {
            console.error(err);
            this.busy = false;
            this.loading = false;
            this.nextAction = () => {};
            this.permissionLevelToChange = null;
            this.changingDatasetPermissions = false;
          });
      })
      .catch((err) => {
        console.error(err);
        this.busy = false;
        this.loading = false;
        this.nextAction = () => {};
        this.permissionLevelToChange = null;
        this.changingDatasetPermissions = false;
      });
    },

    sendDatasetPermissionAction() {
      const data = {
        dataset_pk: [this.currentUsergroupsPermissions[0].dataset],
        ...(this.selectedPermissions.length > 0 || this.selectedAll) && {
          pk : this.selectedAll ? 'all' : this.selectedPermissions.map(el => el.id)
        }
      };
      this.loading = true;
      this.SET_DATASET_USERGROUPS_PERMISSIONS({ level: this.action.code, data: data })
        .then(() => {
          this.GET_DATASET_USERGROUPS_PERMISSIONS({
            ...this.tableSorted,
            id : this.$route.params.id || this.currentUsergroupsPermissions[0].dataset.toString(),
          })
            .then(() => {
              this.RESET_SELECTED_PERMISSIONS();
              this.loading = false;
              this.nextAction = () => {};
              this.permissionLevelToChange = null;
              this.changingDatasetPermissions = false;
            })
            .catch((err) => {
              console.error(err);
              this.RESET_SELECTED_PERMISSIONS();
              this.loading = false;
              this.nextAction = () => {};
              this.permissionLevelToChange = null;
              this.changingDatasetPermissions = false;
            });
        })
        .catch((err) => {
          console.error(err);
          this.loading = false;
          this.nextAction = () => {};
          this.permissionLevelToChange = null;
          this.changingDatasetPermissions = false;
        });
    },

    changeTablePage(e) {
      this.getDatasetPermissions(e);
    },

    loadSearch(e) {
      this.loading = e;
    },

    setTableLoader(e) {
      this.loading = e;
    },

    setTableSorted(e) {
      this.tableSorted = e;
    },

    setGroupFilters(e) {
      const FILTER = 'usergroup_type_id';
      if (e.label === 'Tous' && !e.state) {
        this.groupFilters[0].state = true;

      } else {
        if (e.label !== 'Tous' && e.state) {
          this.groupFilters[0].state = false;
        }
        if (e.label !== 'Tous' && !e.state) {
          if (this.groupFilters.every(el => el.state === false)) {
            this.groupFilters.find(el => el.label === e.label).state = true;
          }
        }
        if (e.label === 'Tous' && e.state) {
          this.groupFilters.forEach((el, i) => {
            if (i !== 0) {
              el.state = false;
            }
          });
        }
        if (this.groupFilters.slice(1).every(el => el.state === true)) {
          this.groupFilters[0].state = true;
          this.groupFilters.forEach((el, i) => {
            if (i !== 0) {
              el.state = false;
            }
          });
        }
      }

      for (const item of this.groupFilters) {
        if (item.state) {
          this.PRE_SET_USERGROUPS_PERMISSIONS_FILTERS({
            filter: FILTER,
            value: item.type !== '' ? this.usergroupsTypes.find(el => el.codename === item.type).id : ''
          });
        } else {
          this.PRE_REMOVE_USERGROUPS_PERMISSIONS_FILTERS({
            filter: FILTER,
            value: item.type !== '' ? this.usergroupsTypes.find(el => el.codename === item.type).id : ''
          });
        }
      }

      this.getDatasetPermissions();
    },

    setAccessLevelFilters(e) {
      const FILTER = 'level';

      this.accessLevelFilters.filter(el => el.label !== e.label).forEach(el => el.state = !e.state);
      this.PRE_SET_USERGROUPS_PERMISSIONS_FILTERS({
        filter: FILTER,
        value: [e.access]
      });

      this.getDatasetPermissions();
    },

    setSelectedPermissions(e) {
      this.SET_SELECTED_PERMISSIONS(e);
    },

    setSelectedAll(e) {
      this.selectedAll = e;
    },
  }
};
</script>

<style lang="less" scoped>

.list-group-item {
  padding: 8px 12px;
  font-size: 0.9em;
  font-weight: 600;
  .btn-group-vertical {
    width: 100%;
    .btn {
      border: none;
      text-align: start;
      font-size: 0.9em;
    }
  }
}

.list-group-item.active {
  padding: 8px 12px;
  background-color: #343a40;
  font-size: 1em;
  font-weight: bold;
}

.default-permission {
  display: flex;
  margin: 1em;
  font-weight: 600;
  color: rgb(87, 87, 87);
  .permissions {
    margin-left: 1em;
    display: flex;
    flex-direction: row;
    button {
      border-radius: 10px;
      font-size: 0.75em;
      font-weight: 600;
      opacity: 0.9;
      box-shadow: 0 0 1px 1px #ccc;
      margin-right: 0.5em;
    }
  }
}

.actions {
  margin-left: 2em;
  font-weight: 600;
  display: flex;
  align-items: center;
  .multiselect {
    width: 340px;
    margin-right: 1em;
  }
}

@media screen and (max-width: 1500px) {
  .search-bar {
    margin-top: 0 !important;
    width: 28.7em;
  }
}
@media screen and (min-width: 1500px) {
  .search-bar {
    margin-top: 0 !important;
    width: 58.5%;
  }
}

</style>
